(function($) {
  Drupal.behaviors.stickyTableColumns = {
    attach: function(context) {

      function createStickyColumns(table, scrollContainer) {
        // start copy table
        var stickyTable = '<table style="border-spacing:' +
          table.css('border-spacing') + ';  margin:' +
          table.css('margin') + ';" class="sticky-columns-table">';
        // start copy header
        stickyTable += '<thead>';
        table.find('thead tr').each(function() {
          var tr = $(this);
          stickyTable += '<tr style="font:' + tr.css("font") + ';" class="' + tr.attr('class') + '">';
          // copy each header cell with styles
          tr.find('th.sticky-column').each(function() {
            var th = $(this);
            stickyTable += '<th style="width:' +
              th.width() + 'px; height:' +
              th.height() + 'px; padding:' +
              th.css("padding") + ';">' + th.html() + '</th>';
          });

          stickyTable += '</tr>';
        });
        stickyTable += '</thead>';
        // start copy body
        table.find('tbody tr').each(function() {
          var tr = $(this);
          stickyTable += '<tr style="font:' + tr.css("font") + ';" class="' + tr.attr('class') + '">';
          // copy each body cell with styles
          tr.find('td.sticky-column').each(function() {
            var td = $(this);
            stickyTable += '<td style="width:' +
              td.width() + 'px; height:' +
              (td.height() + 1) + 'px; padding:' +
              td.css("padding") + ';">' + td.html() + '</td>';
          });

          stickyTable += '</tr>';
        });

        stickyTable += '</table>';
        // add copied table to the page
        var stickyTableElement = $(stickyTable).insertAfter(scrollContainer);
        // show copied table if scroll is used
        var tableZeroLeft = table.offset().left;
        scrollContainer.scroll(function(e) {
          if (table.offset().left < tableZeroLeft) {
            stickyTableElement.show();
          }
          else {
            stickyTableElement.hide();
          }
        });
      }
      
      // initialize sticky columns
      $('table.sticky-columns', context).each(function() {
        $(this).wrap('<div class="sticky-columns-container" style="position:relative;"><div class="scroll-container" style="overflow:auto;">');
        var scrollContainer = $(this).parent();
        createStickyColumns($(this), scrollContainer);
      });
    }
  }
})(jQuery);